config/routes.rb
Rails.application.routes.draw do
  devise_for :forms, :controllers => { registrations: 'registrations' }
  root to: redirect('/posts')
  resources :posts
  resources :forms
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/form.rb
class Form < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/models/post.rb
class Post < ApplicationRecord
	mount_uploader :photo, PhotoUploader

	def next
    	Post.where("id > ?", id).order(id: :asc).limit(1).first
	end

	def previous
		Post.where("id < ?", id).order(id: :desc).limit(1).first
	end

	def last_value
		return Post.order(id: :desc).limit(1).last
	end

	def first_value
		return Post.order(id: :asc).limit(1).first
	end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery with: :exception
  before_action :authenticate_form!
end

app/controllers/forms_controller.rb
class FormsController < ApplicationController
  before_action :set_form, only: [:show, :edit, :update, :destroy]

  # GET /forms
  # GET /forms.json
  def index
    redirect_to root_path, error: "" if current_form.admin != true
    @forms = Form.all
  end

  # GET /forms/1
  # GET /forms/1.json
  def show
    redirect_to root_path, error: "" if current_form.admin != true
  end

  # GET /forms/new
  def new
    @form = Form.new
  end

  # GET /forms/1/edit
  def edit
    redirect_to root_path, error: "" if current_form.admin != true
  end

  # POST /forms
  # POST /forms.json
  def create
    @form = Form.new(form_params)

    respond_to do |format|
      if @form.save
        format.html { redirect_to @form, notice: 'Form was successfully created.' }
        format.json { render :show, status: :created, location: @form }
      else
        format.html { render :new }
        format.json { render json: @form.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /forms/1
  # PATCH/PUT /forms/1.json
  def update
    respond_to do |format|
      if @form.update(form_params)
        format.html { redirect_to @form, notice: 'Form was successfully updated.' }
        format.json { render :show, status: :ok, location: @form }
      else
        format.html { render :edit }
        format.json { render json: @form.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /forms/1
  # DELETE /forms/1.json
  def destroy
    @form.destroy
    respond_to do |format|
      format.html { redirect_to forms_url, notice: 'Form was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_form
      @form = Form.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def form_params
      params.require(:form).permit(:admin)
    end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show, :edit, :update, :destroy]

  # GET /posts
  # GET /posts.json
  def index
    @posts = Post.all.order("created_at desc");
  end

  # GET /posts/1
  # GET /posts/1.json
  def show
  end

  # GET /posts/new
  def new
    @post = Post.new
  end

  # GET /posts/1/edit
  def edit
    redirect_to root_path, error: "" if @post.id_autor != current_form.id && current_form.admin != true
  end

  # POST /posts
  # POST /posts.json
  def create
    @post = Post.new(post_params)
    @post.id_autor = current_form.id
    respond_to do |format|
      if @post.save
        format.html { redirect_to @post, notice: 'Post was successfully created.' }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1
  # PATCH/PUT /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to @post, notice: 'Post was successfully updated.' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1
  # DELETE /posts/1.json
  def destroy
    @post.destroy
    respond_to do |format|
      format.html { redirect_to posts_url, notice: 'Post was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_post
      @post = Post.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def post_params
      params.require(:post).permit(:photo, :title, :description, :id_autor)
    end
end

app/controllers/registrations_controller.rb
class RegistrationsController < Devise::RegistrationsController

  private

  def sign_up_params
    params.require(:form).permit(:user_name, :email, :password, :password_confirmation)
  end

  def account_update_params
    params.require(:form).permit(:user_name, :email, :password, :password_confirmation, :current_password)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/forms_helper.rb
module FormsHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/forms/_form.html.erb
<%= form_with(model: form, local: true) do |form| %>

  <div class="field">
    <%= form.label :admin %>
    <%= form.check_box :admin, id: :form_admin %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/forms/edit.html.erb
<h1>Editing Form</h1>

<%= render 'form', form: @form %>

<%= link_to 'Show', @form %> |
<%= link_to 'Back', forms_path %>

app/views/forms/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Forms</h1>

<table>
  <thead>
    <tr>
      <th>Admin</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @forms.each do |form| %>
      <tr>
        <td><%= form.admin %></td>
        <td><%= link_to 'Show', form %></td>
        <td><%= link_to 'Edit', edit_form_path(form) %></td>
        <td><%= link_to 'Destroy', form, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Form', new_form_path %>

app/views/forms/new.html.erb
<h1>New Form</h1>

<%= render 'form', form: @form %>

<%= link_to 'Back', forms_path %>

app/views/forms/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Admin:</strong>
  <%= @form.admin %>
</p>

<%= link_to 'Edit', edit_form_path(@form) %> |
<%= link_to 'Back', forms_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
    <title>MemeBook</title>
    <%= csrf_meta_tags %>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.0.3/css/bootstrap.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.0.3/css/bootstrap-theme.css">
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>


  <body style="background-color: #141518; font-family: OpenSans; border: none">
    <nav class="navbar navbar-default navbar-fixed-top" role="navigation">
      <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
              <span class="sr-only">Toggle navigation</span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
              <span class="icon-bar"></span>
            </button>
        </div>
        <div id="modal-holder"></div>
        <div class="collapse navbar-collapse">
            <ul class="nav navbar-nav" style="padding: 10px">
              <li style="padding: 0px"><a href="/posts" style="padding: 5px"> <img src="https://i.imgur.com/6QAOJRk.png" height=20 width=136/></a>
              </li>
              <li style="padding: 0px; padding-left: 30px;">
                <form method="New" action="/posts/new" class="button_to">
                  <strong>
                    <input value="New post" type="submit" style="width: 120px; background-image: url(https://i.imgur.com/gGQUoSO.png); text-align: right; color: black; font-size: 15px" />
                  </strong>
                </form>"
              </li>  
            </ul>
            <p class="navbar-text pull-right" style="padding: 0px">
              <% if form_signed_in? %>
                Usuário Logado: <strong><%= current_form.user_name %></strong> &nbsp;
                <%= link_to 'Edit Profile', edit_form_registration_path(current_form.id), :class => 'navbar-link' %> |
                <%= link_to "Logout", destroy_form_session_path, method: :delete, :class => 'navbar-link'  %>
              <% else %>
                <%= link_to "Register", new_form_registration_path, :class => 'navbar-link'  %> |
                <%= link_to "Login", new_form_session_path, :class => 'navbar-link'  %>
              <% end %>
        </div>
      </div>
  </nav>
    <div class="container">
      <% if notice %>
        <p class="alert alert-success"><%= notice %></p>
      <% end %>
      <% if alert %>
        <p class="alert alert-danger"><%= alert %></p>
      <% end %>
      <%= yield %>
  </div>
  <footer>
    <hr style="border-color: #34373c">
      <div class="container">
        <%= %> © MemeBook - 2017
      </div>
  </footer>
  <script src="//maxcdn.bootstrapcdn.com/bootstrap/3.0.3/js/bootstrap.js"></script>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_with(model: post, local: true) do |form| %>
  <% if post.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
      <% post.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div style="background-color: #34373c; padding: 20px; border-radius: 5px">
    <div class="field">
      <%= form.label :photo, {:style=>'color:#FFFFFF;'} %>
      <%= form.file_field :photo, id: :post_photo, :required => true %>
    </div>

    <br />

    <div class="field">
      <%= form.label :title, {:style=>'color:#FFFFFF;'} %>
      <br />
      <%= form.text_field :title, id: :post_title, :required => true %>
    </div>

    <br />

    <div class="field">
      <%= form.label :description, {:style=>'color:#FFFFFF;'} %>
      <br />
      <%= form.text_area :description, id: :post_description, :required => true %>
    </div>

    <br />

    <div class="actions">
      <%= form.submit %>
    </div>
  </div>
<% end %>

app/views/posts/edit.html.erb
<h1>Editing Post</h1>

<%= render 'form', post: @post %>

app/views/posts/index.html.erb
<h1 style="text-align: center; font-size: 28px; color: white; font-family: OpenSans">
  Share the pleasure of laughter, Share Memes!
</h1>
<h5 style="text-align: center; font-size: 15px; font-family: OpenSans; color: grey">
  <i>
    Latest Publications.
  </i>
</h5>
<br />

<% if current_form.admin == true %>
  <a href="/forms"> EditUsers </a>
<% end %>

<% if @posts %>
  <div style="background-color: #34373c; padding: 20px; border-radius: 5px">
    <% @posts.in_groups_of(6) do |group| %>
        <div class="row">
          <% group.compact.each do |post| %>
              <div class="col-md-2">
                <div class="totalContent">
                  <a>
                    <%= link_to (image_tag post.photo_url, width: '160'), post_path(post) %>
                  </a>
                </div>
                <br />
              </div>
          <% end %>
        </div>
    <% end %>
  </div>
<% end %>

<a href="/">
  <h5 style="text-align: right;">
    Back to top
  </h5>
</a>

app/views/posts/new.html.erb
<h1 style="color:white">New Post</h1>

<%= render 'form', post: @post %>

app/views/posts/show.html.erb
<br />
<div style="background-color: #34373c; padding: 20px; border-radius: 5px">
  <div class="row">
    <div class="col-md-9">
      <%= image_tag(@post.photo_url, width: '100%') if @post.photo.present? %>
    </div>

    <div class="col-md-3" style="color: white">
      <p><b>Name: </b><%= @post.title %></p>
      <p><b>Description: </b><%= @post.description %></p>
      <br /> <br />
      <p style="text-align: center">
        <% if @post.id != @post.last_value.id %>
          <button class="bt">
            <strong>
              <%= link_to 'Previous', @post.next, {:style=>'color:#FFFFFF;'} %>
            </strong>
          </button>
          &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <% end %>
        <% if @post.id != @post.first_value.id %>
          <button class="bt">
            <strong>
              <%= link_to 'Next', @post.previous, {:style=>'color:#FFFFFF;'} %>
            </strong>
          </button>
        <% end %>    
      </p>
      <p style="text-align: center">
        <br /> <br />
    	  <% if @post.id_autor == current_form.id or current_form.admin == true %>
          <button class="bt">
            <strong>
    		      <%= link_to 'Edit', edit_post_path(@post), {:style=>'color:#FFFFFF;'} %>
            </strong>
    	    </button>
        <% end %>
      </p>
    </div>
  </div>
</div>